var gulp = require('gulp');
var Elixir = require('laravel-elixir');
var htmlmin = require('gulp-htmlmin');
var template = require('gulp-template-compile');
var config = require('./Config');

Elixir.extend(config.underscoreTemplates.taskName, function(src, dest, filename) {

  filename = filename || config.underscoreTemplates.defaultFilename;
  dest = dest || config.publicPath + '/js';

  if ( typeof (src) == 'string') {
    src = config.assetsPath + '/' + src
  }

  if ( typeof (src) == 'object') {
    src.forEach(function(value, key) {
      src[key] = config.assetsPath + '/' + value
    });
  }

  new Elixir.Task(config.underscoreTemplates.taskName, function() {

    gulp
      .src(src)

      .pipe(Elixir.Plugins.sourcemaps.init())

      .pipe(htmlmin({
        collapseWhitespace: true,
        conservativeCollapse: true
      }))
      .pipe(template({
        namespace: config.underscoreTemplates.namespace,
        templateSettings: config.underscoreTemplates.templateSettings
      }))
      .pipe(Elixir.Plugins.concat(filename))

      .pipe(Elixir.Plugins.sourcemaps.write())

      .pipe(gulp.dest(dest))

  })
  .watch(src)

});
